package com.casic.dcms.mvp.model;

import com.casic.dcms.bean.CaseStatusBean;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class CaseStatusModelImpl implements ICaseStatusModel {

    private OnGetCaseStatusListener listener;

    public CaseStatusModelImpl(OnGetCaseStatusListener onGetCaseStatusListener) {
        this.listener = onGetCaseStatusListener;
    }

    public interface OnGetCaseStatusListener {
        void onSuccess(CaseStatusBean resultBean);

        void onFailure(Throwable throwable);
    }

    @Override
    public Subscription sendRetrofitRequest() {
        Observable<CaseStatusBean> observable = RetrofitServiceManager.getCaseStatusResult();
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<CaseStatusBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    listener.onFailure(e);
                }
            }

            @Override
            public void onNext(CaseStatusBean resultBean) {
                if (resultBean != null) {
                    listener.onSuccess(resultBean);
                }
            }
        });
    }
}
